'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _isEqual = require('lodash/isEqual');

var _isEqual2 = _interopRequireDefault(_isEqual);

var _zipWith = require('lodash/zipWith');

var _zipWith2 = _interopRequireDefault(_zipWith);

var _getMountableComponent = require('./getMountableComponent');

var _getMountableComponent2 = _interopRequireDefault(_getMountableComponent);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /* eslint-disable no-console, no-underscore-dangle, import/no-extraneous-dependencies */


var Region = function (_React$Component) {
  _inherits(Region, _React$Component);

  _createClass(Region, null, [{
    key: 'sendProps',
    value: function sendProps(appInstance, props) {
      var regionService = appInstance.get(appInstance.options.providerNames.region);

      if (!regionService) {
        return;
      }

      regionService.emit(props);
    }
  }]);

  function Region(props, context) {
    _classCallCheck(this, Region);

    var _this = _possibleConstructorReturn(this, (Region.__proto__ || Object.getPrototypeOf(Region)).call(this, props, context));

    if (context.app) {
      var rootApp = context.app.getRootApp();
      var list = rootApp._appsCollection.filter(function (_ref) {
        var regions = _ref.regions;

        return regions.some(function (name) {
          return props.name === name;
        });
      });

      _this.state = {
        list: list,
        listForRendering: _this.getListForRendering(list, rootApp)
      };
    } else {
      _this.state = {
        list: [], // array of apps ==> { name, instance }
        listForRendering: [] // array of { name, Component } objects
      };
    }
    return _this;
  }

  _createClass(Region, [{
    key: 'getListForRendering',
    value: function getListForRendering(list, rootApp) {
      var _this2 = this;

      var listForRendering = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];

      var _props = this.props,
          children = _props.children,
          className = _props.className,
          props = _objectWithoutProperties(_props, ['children', 'className']);

      return list.map(function (item) {
        var name = item.name,
            weight = item.weight,
            multi = item.multi;

        var isPresent = listForRendering.some(function (w) {
          return w.name === name;
        });

        // @TODO: take care of removal in streamed list too?
        if (isPresent) {
          return null;
        }

        var regionArgs = _this2.props.uniqueKey ? [_this2.props.name, _this2.props.uniqueKey] : [_this2.props.name];

        if (_this2.props.uniqueKey && !rootApp.hasAppInstance.apply(rootApp, [name].concat(regionArgs))) {
          rootApp.instantiateApp.apply(rootApp, [name].concat(regionArgs));
        }

        var instance = rootApp.getAppInstance.apply(rootApp, [name].concat(regionArgs));

        if (instance) {
          Region.sendProps(instance, props);
        }

        return {
          name: name,
          weight: weight,
          instance: instance,
          multi: multi,
          Component: (0, _getMountableComponent2.default)(instance)
        };
      }).filter(function (item) {
        return !!item;
      }).concat(listForRendering).sort(function (a, b) {
        return a.weight - b.weight;
      });
    }
  }, {
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var shouldUpdate = !(0, _isEqual2.default)(this.props, nextProps);

      if (!shouldUpdate) {
        var listForRendering = nextState.listForRendering;

        shouldUpdate = shouldUpdate || this.state.listForRendering.length !== listForRendering.length;
        shouldUpdate = shouldUpdate || (0, _zipWith2.default)(this.state.listForRendering, listForRendering, function (a, b) {
          return a.name === b.name;
        }).some(function (value) {
          return !value;
        });
      }

      return shouldUpdate;
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      if (!this.context.app) {
        return;
      }

      var rootApp = this.context.app.getRootApp();

      this.rootApp = rootApp;
      var apps$ = rootApp.getApps$(this.props.name, this.props.uniqueKey);

      this._subscription = apps$.subscribe({
        next: function next(list) {
          _this3.setState({
            list: list,
            listForRendering: _this3.getListForRendering(list, rootApp, _this3.state.listForRendering)
          });
        },
        error: function error(err) {
          console.warn('Subscription error for <Region name="' + _this3.name + '" />:', err);
        }
      });
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var children = nextProps.children,
          className = nextProps.className,
          props = _objectWithoutProperties(nextProps, ['children', 'className']);

      this.state.listForRendering.filter(function (item) {
        return item.instance;
      }).forEach(function (item) {
        return Region.sendProps(item.instance, props);
      });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var _this4 = this;

      if (this._subscription) {
        this._subscription.unsubscribe();
      }

      if (this.rootApp) {
        this.state.listForRendering.filter(function (item) {
          return item.multi;
        }).forEach(function (item) {
          _this4.rootApp.destroyApp(item.name, _this4.props.name, _this4.props.uniqueKey);
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var listForRendering = this.state.listForRendering;


      if (listForRendering.length === 0) {
        return null;
      }

      var _props2 = this.props,
          className = _props2.className,
          children = _props2.children,
          props = _objectWithoutProperties(_props2, ['className', 'children']);

      if (typeof children === 'function') {
        return _react2.default.createElement(
          'div',
          { className: className },
          children(listForRendering, props)
        );
      }

      return _react2.default.createElement(
        'div',
        { className: className },
        listForRendering.map(function (item) {
          var Component = item.Component,
              name = item.name;


          return _react2.default.createElement(Component, _extends({}, props, { key: 'app-' + name }));
        })
      );
    }
  }]);

  return Region;
}(_react2.default.Component);

Region.propTypes = {
  children: _propTypes2.default.func,
  className: _propTypes2.default.string,
  name: _propTypes2.default.string.isRequired,
  uniqueKey: _propTypes2.default.string,
  data: _propTypes2.default.any
};
Region.contextTypes = {
  app: _propTypes2.default.object
};
exports.default = Region;
module.exports = exports['default'];