'use strict';

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; /* eslint-disable import/no-extraneous-dependencies, func-names */
/* global describe, it */


var _chai = require('chai');

var _frintComponentUtils = require('frint-component-utils');

var _ReactHandler = require('./ReactHandler');

var _ReactHandler2 = _interopRequireDefault(_ReactHandler);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('frint-react › ReactHandler', function () {
  var component = {
    state: {
      text: ''
    },
    setState: function setState(newState, cb) {
      this.state = _extends({}, this.state, newState);
      cb && cb();
    },

    props: {
      value: 'hi'
    }
  };

  it('is an object', function () {
    (0, _chai.expect)(_ReactHandler2.default).to.be.an('object');
  });

  it('gets and sets data from component', function () {
    var handler = (0, _frintComponentUtils.composeHandlers)(_ReactHandler2.default, {
      component: component
    });

    handler.setData('text', 'hello');
    (0, _chai.expect)(handler.getData('text')).to.equal('hello');
    handler.setDataWithCallback('text', 'hello1', function () {});
    (0, _chai.expect)(handler.getData('text')).to.equal('hello1');
    (0, _chai.expect)(handler.getProps()).to.have.property('value', 'hi');
    (0, _chai.expect)(handler.getProp('value')).to.equal('hi');
  });
});