'use strict';

var _chai = require('chai');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _frint = require('frint');

var _render = require('./render');

var _render2 = _interopRequireDefault(_render);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable import/no-extraneous-dependencies, func-names */
/* globals describe, document, it, beforeEach, resetDOM */
describe('frint-react › render', function () {
  function TestComponent() {
    return _react2.default.createElement(
      'p',
      null,
      'Hello World from TestApp!'
    );
  }

  var TestApp = (0, _frint.createApp)({
    name: 'TestApp',
    providers: [{
      name: 'component',
      useValue: TestComponent
    }]
  });

  beforeEach(function () {
    resetDOM();
  });

  it('renders app to DOM', function () {
    var app = new TestApp();
    var rootEl = document.getElementById('root');
    (0, _render2.default)(app, rootEl);

    (0, _chai.expect)(rootEl.innerHTML).to.contain('Hello World from TestApp!</p>');
  });
});